Index: src/main/java/com/xpn/xwiki/user/impl/xwiki/XWikiRightServiceImpl.java
===================================================================
--- src/main/java/com/xpn/xwiki/user/impl/xwiki/XWikiRightServiceImpl.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/user/impl/xwiki/XWikiRightServiceImpl.java	(working copy)
@@ -23,6 +23,8 @@
 
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.AccessLevel;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.objects.BaseObject;
 import com.xpn.xwiki.user.api.XWikiGroupService;
@@ -39,10 +41,7 @@
 
 public class XWikiRightServiceImpl implements XWikiRightService {
     private static final Log log = LogFactory.getLog(XWikiRightServiceImpl.class);
-    private static Map actionMap;
-    private static List allLevels = Arrays.asList(
-        new String[] {"admin","view","edit","comment","delete","register","programming"});
-
+    
     protected void logAllow(String username, String page, String action, String info) {
         if (log.isDebugEnabled())
             log.debug("Access has been granted for (" + username + "," + page + "," + action + "): " + info);
@@ -58,56 +57,49 @@
             log.debug("Access has been denied for (" + name + "," + resourceKey + "," + accessLevel + ") at " + info, e);
     }
 
+    /**
+     * This function returns all the access levels as Strings the returned list is the union between 
+     * regular levels and global levels.
+     * @deprecated use {@link XWikiRightServiceImpl#listRegularLevels(XWikiContext)} and 
+     * {@link XWikiRightServiceImpl#listGlobalLevels(XWikiContext)}.
+     */
     public List listAllLevels(XWikiContext context) throws XWikiException {
-        List list = new ArrayList();
-        list.addAll(allLevels);
-        return list;
-    }
-
-    public String getRight(String action) {
-        if (actionMap == null) {
-            actionMap = new HashMap();
-            actionMap.put("login", "login");
-            actionMap.put("logout", "login");
-            actionMap.put("loginerror", "login");
-            actionMap.put("loginsubmit", "login");
-            actionMap.put("view", "view");
-            actionMap.put("viewrev", "view");
-            actionMap.put("downloadrev", "download");
-            actionMap.put("plain", "view");
-            actionMap.put("raw", "view");
-            actionMap.put("attach", "view");
-            actionMap.put("charting", "view");
-            actionMap.put("skin", "view");
-            actionMap.put("download", "view");
-            actionMap.put("dot", "view");
-            actionMap.put("svg", "view");
-            actionMap.put("pdf", "view");
-            actionMap.put("delete", "delete");
-            actionMap.put("reset", "delete");
-            actionMap.put("commentadd", "comment");
-            actionMap.put("register", "register");
-            actionMap.put("redirect", "view");
-            actionMap.put("admin", "admin");
-            actionMap.put("export", "view");
-            actionMap.put("import", "admin");
-            actionMap.put("unknown", "view");
+        List rAccessLevels = AccessLevel.listRegularAccessLevels();
+        List gAccessLevels = AccessLevel.listGlobalAccessLevels();
+        ArrayList allLevelsList = new ArrayList();
+        allLevelsList.addAll(rAccessLevels);
+        for(Iterator it = gAccessLevels.iterator(); it.hasNext();) {
+            AccessLevel currentLevel = (AccessLevel)it.next();
+            //find it
+            if (allLevelsList.contains(currentLevel)) {
+                continue;
+            } else {
+                allLevelsList.add(currentLevel);
+            }            
         }
-
-        String right = (String) actionMap.get(action);
-        if (right == null) {
-            return "edit";
-        } else
-            return right;
+        
+        ArrayList stringAccessLevels = new ArrayList();
+        for (Iterator it = allLevelsList.iterator(); it.hasNext();) {
+            stringAccessLevels.add(it.next().toString());
+        }
+        return stringAccessLevels;
     }
+    
+    public List listRegularLevels(XWikiContext context) throws XWikiException {
+        return AccessLevel.listRegularAccessLevels();
+    }
+    
+    public List listGlobalLevels(XWikiContext context) throws XWikiException {
+        return AccessLevel.listGlobalAccessLevels();
+    }
 
-    public boolean checkAccess(String action, XWikiDocument doc, XWikiContext context) throws XWikiException {
+    public boolean checkAccess(DocumentAction action, XWikiDocument doc, XWikiContext context) throws XWikiException {
         String username = null;
         XWikiUser user = null;
         boolean needsAuth = false;
-        String right = getRight(action);
+        AccessLevel right = action.getAccessLevel();
 
-        if (right.equals("login")) {
+        if (right.equals(AccessLevel.LOGIN)) {
             user = context.getWiki().checkAuth(context);
             if (user == null)
                 username = "XWiki.XWikiGuest";
@@ -116,11 +108,11 @@
 
             // Save the user
             context.setUser(username);
-            logAllow(username, doc.getFullName(), action, "login/logout pages");
+            logAllow(username, doc.getFullName(), action.toString(), "login/logout pages");
             return true;
         }
 
-        if (right.equals("delete")) {
+        if (right.equals(AccessLevel.DELETE)) {
             user = context.getWiki().checkAuth(context);
             String creator = doc.getCreator();
             if ((user != null) && (user.getUser() != null) && (creator != null)) {
@@ -128,7 +120,7 @@
                     return true;
                 }
             }
-            right = "admin";
+            right = AccessLevel.ADMIN;
         }
 
         // We do not need to authenticate twice
@@ -145,7 +137,7 @@
                 if ((user == null) && (needsAuth)) {
                     if (context.getRequest() != null)
                         context.getWiki().getAuthService().showLogin(context);
-                    logDeny("unauthentified", doc.getFullName(), action, "Authentication needed");
+                    logDeny("unauthentified", doc.getFullName(), action.toString(), "Authentication needed");
                     return false;
                 }
             } catch (XWikiException e) {
@@ -176,29 +168,29 @@
                 docname = doc.getFullName();
 
             if (context.getWiki().getRightService().hasAccessLevel(right, username, docname, context)) {
-                logAllow(username, docname, action, "access manager granted right");
+                logAllow(username, docname, action.toString(), "access manager granted right");
                 return true;
             }
         } catch (Exception e) {
 // This should not happen..
-            logDeny(username, (doc==null) ? "" : doc.getFullName(), action, "access manager exception " + e.getMessage());
+            logDeny(username, (doc==null) ? "" : doc.getFullName(), action.toString(), "access manager exception " + e.getMessage());
             e.printStackTrace();
             return false;
         }
 
         if (user == null) {
 // Denied Guest need to be authenticated
-            logDeny("unauthentified", (doc==null) ? "" : doc.getFullName(), action, "Guest has been denied - Redirecting to authentication");
+            logDeny("unauthentified", (doc==null) ? "" : doc.getFullName(), action.toString(), "Guest has been denied - Redirecting to authentication");
             if (context.getRequest() != null)
                 context.getWiki().getAuthService().showLogin(context);
             return false;
         } else {
-            logDeny(username, doc.getFullName(), action, "access manager denied right");
+            logDeny(username, doc.getFullName(), action.toString(), "access manager denied right");
             return false;
         }
     }
 
-    private boolean needsAuth(String right, XWikiContext context) {
+    private boolean needsAuth(AccessLevel right, XWikiContext context) {
         boolean needsAuth = false;
         try {
             needsAuth = context.getWiki().getXWikiPreference("authenticate_" + right, "", context).toLowerCase().equals("yes");
@@ -219,15 +211,24 @@
         return needsAuth;
     }
 
-    public boolean hasAccessLevel(String right, String username, String docname, XWikiContext context) throws XWikiException {
+    public boolean hasAccessLevel(AccessLevel right, String username, String docname, XWikiContext context) throws XWikiException {
         try {
             return hasAccessLevel(right, username, docname, true, context);
         } catch (XWikiException e) {
             return false;
         }
     }
+    
+    /**
+     * @see XWikiRightServiceImpl#hasAccessLevel(AccessLevel, String, String, XWikiContext) 
+     * @deprecated use {@link XWikiRightServiceImpl#hasAccessLevel(AccessLevel, String, String, XWikiContext)}
+     */
+    public boolean hasAccessLevel(String right, String username, String docname, XWikiContext context) throws XWikiException {
+        AccessLevel accessLevel = AccessLevel.valueOf(right);
+        return this.hasAccessLevel(accessLevel, username, docname, context);
+    }
 
-    public boolean checkRight(String name, XWikiDocument doc, String accessLevel,
+    public boolean checkRight(String name, XWikiDocument doc, AccessLevel accessLevel,
                               boolean user, boolean allow, boolean global, XWikiContext context) throws XWikiRightNotFoundException, XWikiException {
         String className = global ? "XWiki.XWikiGlobalRights" : "XWiki.XWikiRights";
         String fieldName = user ? "users" : "groups";
@@ -270,7 +271,7 @@
                         log.debug("Checking match: " + accessLevel + " in " + levels);
 
                     String[] levelsarray = StringUtils.split(levels, " ,|");
-                    if (ArrayUtils.contains(levelsarray, accessLevel)) {
+                    if (ArrayUtils.contains(levelsarray, accessLevel.toString())) {
                         if (log.isDebugEnabled())
                             log.debug("Found a right for " + allow);
                         found = true;
@@ -422,7 +423,7 @@
             throw new XWikiRightNotFoundException();
     }
 
-    public boolean hasAccessLevel(String accessLevel, String name, String resourceKey,
+    public boolean hasAccessLevel(AccessLevel accessLevel, String name, String resourceKey,
                                   boolean user, XWikiContext context) throws XWikiException {
         boolean deny = false;
         boolean allow = false;
@@ -434,11 +435,11 @@
 
         if (isReadOnly) {
 
-            if ("edit".equals(accessLevel) ||
-                    "delete".equals(accessLevel) ||
-                    "comment".equals(accessLevel) ||
-                    "register".equals(accessLevel)) {
-                logDeny(name, resourceKey, accessLevel, "server in read-only mode");
+            if (AccessLevel.EDIT.equals(accessLevel) ||
+                    AccessLevel.DELETE.equals(accessLevel) ||
+                    AccessLevel.COMMENT.equals(accessLevel) ||
+                    AccessLevel.REGISTER.equals(accessLevel)) {
+                logDeny(name, resourceKey, accessLevel.toString(), "server in read-only mode");
                 return false;
             }
         }
@@ -449,7 +450,7 @@
         }
 
         allow = isSuperAdminOrProgramming(name, resourceKey, accessLevel, user, context);
-        if ((allow==true)||(accessLevel.equals("programming"))) {
+        if ((allow==true)||(accessLevel.equals(AccessLevel.PROGRAMMING))) {
             return allow;
         }
 
@@ -458,7 +459,7 @@
             String wikiOwner = context.getWikiOwner();
             if (wikiOwner != null) {
                 if (wikiOwner.equals(name)) {
-                    logAllow(name, resourceKey, accessLevel, "admin level from wiki ownership");
+                    logAllow(name, resourceKey, accessLevel.toString(), "admin level from wiki ownership");
                     return true;
                 }
             }
@@ -466,26 +467,26 @@
             XWikiDocument xwikidoc = context.getWiki().getDocument("XWiki.XWikiPreferences", context);
 
             // Verify XWiki register right
-            if (accessLevel.equals("register")) {
+            if (accessLevel.equals(AccessLevel.REGISTER)) {
                 try {
-                    allow = checkRight(name, xwikidoc, "register", user, true, true, context);
+                    allow = checkRight(name, xwikidoc, AccessLevel.REGISTER, user, true, true, context);
                     if (allow) {
-                        logAllow(name, resourceKey, accessLevel, "register level");
+                        logAllow(name, resourceKey, accessLevel.toString(), "register level");
                         return true;
                     } else {
-                        logDeny(name, resourceKey, accessLevel, "register level");
+                        logDeny(name, resourceKey, accessLevel.toString(), "register level");
                         return false;
                     }
                 } catch (XWikiRightNotFoundException e) {
                 }
-                logDeny(name, resourceKey, accessLevel, "register level (no right found)");
+                logDeny(name, resourceKey, accessLevel.toString(), "register level (no right found)");
                 return false;
             }
 
             int maxRecursiveSpaceChecks = context.getWiki().getMaxRecursiveSpaceChecks(context);
             boolean isSuperUser = isSuperUser(accessLevel, name, resourceKey, user, xwikidoc, maxRecursiveSpaceChecks, context);
             if (isSuperUser) {
-                logAllow(name, resourceKey, accessLevel, "admin level");
+                logAllow(name, resourceKey, accessLevel.toString(), "admin level");
                 return true;
             }
 
@@ -498,7 +499,7 @@
                     deny = checkRight(name, currentdoc, accessLevel, user, false, false, context);
                     deny_found = true;
                     if (deny) {
-                        logDeny(name, resourceKey, accessLevel, "document level");
+                        logDeny(name, resourceKey, accessLevel.toString(), "document level");
                         return false;
                     }
                 } catch (XWikiRightNotFoundException e) {
@@ -510,7 +511,7 @@
                 allow = checkRight(name, currentdoc, accessLevel, user, true, false, context);
                 allow_found = true;
                 if (allow) {
-                    logAllow(name, resourceKey, accessLevel, "document level");
+                    logAllow(name, resourceKey, accessLevel.toString(), "document level");
                     return true;
                 }
             } catch (XWikiRightNotFoundException e) {
@@ -534,7 +535,7 @@
                             deny = checkRight(name, webdoc, accessLevel, user, false, true, context);
                             deny_found = true;
                             if (deny) {
-                                logDeny(name, resourceKey, accessLevel, "web level");
+                                logDeny(name, resourceKey, accessLevel.toString(), "web level");
                                 return false;
                             }
                         } catch (XWikiRightNotFoundException e) {
@@ -548,7 +549,7 @@
                             allow = checkRight(name, webdoc, accessLevel, user, true, true, context);
                             allow_found = true;
                             if (allow) {
-                                logAllow(name, resourceKey, accessLevel, "web level");
+                                logAllow(name, resourceKey, accessLevel.toString(), "web level");
                                 return true;
                             }
                         } catch (XWikiRightNotFoundException e) {
@@ -574,7 +575,7 @@
                     deny = checkRight(name, xwikidoc, accessLevel, user, false, true, context);
                     deny_found = true;
                     if (deny) {
-                        logDeny(name, resourceKey, accessLevel, "xwiki level");
+                        logDeny(name, resourceKey, accessLevel.toString(), "xwiki level");
                         return false;
                     }
                 } catch (XWikiRightNotFoundException e) {
@@ -588,7 +589,7 @@
                     allow = checkRight(name, xwikidoc, accessLevel, user, true, true, context);
                     allow_found = true;
                     if (allow) {
-                        logAllow(name, resourceKey, accessLevel, "xwiki level");
+                        logAllow(name, resourceKey, accessLevel.toString(), "xwiki level");
                         return true;
                     }
                 } catch (XWikiRightNotFoundException e) {
@@ -599,20 +600,20 @@
 // and that all users that were not denied
 // should be allowed.
             if (!allow_found) {
-                if (accessLevel.equals("register")) {
-                    logDeny(name, resourceKey, accessLevel, "global level (register right must be explicit)");
+                if (accessLevel.equals(AccessLevel.REGISTER)) {
+                    logDeny(name, resourceKey, accessLevel.toString(), "global level (register right must be explicit)");
                     return false;
                 } else {
-                    logAllow(name, resourceKey, accessLevel, "global level (no restricting right)");
+                    logAllow(name, resourceKey, accessLevel.toString(), "global level (no restricting right)");
                     return true;
                 }
             } else {
-                logDeny(name, resourceKey, accessLevel, "global level (restricting right was found)");
+                logDeny(name, resourceKey, accessLevel.toString(), "global level (restricting right was found)");
                 return false;
             }
 
         } catch (XWikiException e) {
-            logDeny(name, resourceKey, accessLevel, "global level (exception)", e);
+            logDeny(name, resourceKey, accessLevel.toString(), "global level (exception)", e);
             e.printStackTrace();
             return false;
         }
@@ -625,11 +626,11 @@
         return true;
     }
 
-    private boolean isSuperAdminOrProgramming(String name, String resourceKey, String accessLevel, boolean user, XWikiContext context) throws XWikiException {
+    private boolean isSuperAdminOrProgramming(String name, String resourceKey, AccessLevel accessLevel, boolean user, XWikiContext context) throws XWikiException {
         String database = context.getDatabase();
         boolean allow;
         if (name.equals("XWiki.superadmin") || name.endsWith(":XWiki.superadmin")) {
-            logAllow(name, resourceKey, accessLevel, "super admin level");
+            logAllow(name, resourceKey, accessLevel.toString(), "super admin level");
             return true;
         }
 
@@ -639,32 +640,32 @@
             XWikiDocument xwikimasterdoc = context.getWiki().getDocument("XWiki.XWikiPreferences", context);
 // Verify XWiki Master super user
             try {
-                allow = checkRight(name, xwikimasterdoc, "admin", true, true, true, context);
+                allow = checkRight(name, xwikimasterdoc, AccessLevel.ADMIN, true, true, true, context);
                 if (allow) {
-                    logAllow(name, resourceKey, accessLevel, "master admin level");
+                    logAllow(name, resourceKey, accessLevel.toString(), "master admin level");
                     return true;
                 }
             } catch (XWikiRightNotFoundException e) {
             }
 
 // Verify XWiki programming right
-            if (accessLevel.equals("programming")) {
+            if (accessLevel.equals(AccessLevel.PROGRAMMING)) {
                 // Programming right can only been given if user is from main wiki
                 if (!name.startsWith(context.getWiki().getDatabase() + ":"))
                     return false;
 
                 try {
-                    allow = checkRight(name, xwikimasterdoc, "programming", user, true, true, context);
+                    allow = checkRight(name, xwikimasterdoc, AccessLevel.PROGRAMMING, user, true, true, context);
                     if (allow) {
-                        logAllow(name, resourceKey, accessLevel, "programming level");
+                        logAllow(name, resourceKey, accessLevel.toString(), "programming level");
                         return true;
                     } else {
-                        logDeny(name, resourceKey, accessLevel, "programming level");
+                        logDeny(name, resourceKey, accessLevel.toString(), "programming level");
                         return false;
                     }
                 } catch (XWikiRightNotFoundException e) {
                 }
-                logDeny(name, resourceKey, accessLevel, "programming level (no right found)");
+                logDeny(name, resourceKey, accessLevel.toString(), "programming level (no right found)");
                 return false;
             }
         } finally {
@@ -675,14 +676,14 @@
         return false;
     }
 
-    private boolean isSuperUser(String accessLevel, String name, String resourceKey, boolean user, XWikiDocument xwikidoc, int maxRecursiveSpaceChecks, XWikiContext context) throws XWikiException {
+    private boolean isSuperUser(AccessLevel accessLevel, String name, String resourceKey, boolean user, XWikiDocument xwikidoc, int maxRecursiveSpaceChecks, XWikiContext context) throws XWikiException {
        boolean allow;
 
         // Verify XWiki super user
         try {
-            allow = checkRight(name, xwikidoc, "admin", user, true, true, context);
+            allow = checkRight(name, xwikidoc, AccessLevel.ADMIN, user, true, true, context);
             if (allow) {
-                logAllow(name, resourceKey, accessLevel, "admin level");
+                logAllow(name, resourceKey, accessLevel.toString(), "admin level");
                 return true;
             }
         } catch (XWikiRightNotFoundException e) {
@@ -700,9 +701,9 @@
             XWikiDocument webdoc = context.getWiki().getDocument(web, "WebPreferences", context);
             if (!webdoc.isNew()) {
                 try {
-                    allow = checkRight(name, webdoc, "admin", user, true, true, context);
+                    allow = checkRight(name, webdoc, AccessLevel.ADMIN, user, true, true, context);
                     if (allow) {
-                        logAllow(name, resourceKey, accessLevel, "web admin level");
+                        logAllow(name, resourceKey, accessLevel.toString(), "web admin level");
                         return true;
                     }
                 } catch (XWikiRightNotFoundException e) {
@@ -752,7 +753,7 @@
                     return false;
             }
 
-            return hasAccessLevel("programming", username, docname, context);
+            return hasAccessLevel(AccessLevel.PROGRAMMING, username, docname, context);
         } catch (Exception e) {
             e.printStackTrace();
             return false;
@@ -762,14 +763,14 @@
     public boolean hasAdminRights(XWikiContext context) {
         boolean hasAdmin = false;
         try {
-            hasAdmin = hasAccessLevel("admin", context.getUser(),
+            hasAdmin = hasAccessLevel(AccessLevel.ADMIN, context.getUser(),
                     "XWiki.XWikiPreferences", context);
         } catch (Exception e) {
             e.printStackTrace();
         }
         if (!hasAdmin) {
             try {
-                hasAdmin = hasAccessLevel("admin", context.getUser(),
+                hasAdmin = hasAccessLevel(AccessLevel.ADMIN, context.getUser(),
                         context.getDoc().getSpace() + ".WebPreferences", context);
             } catch (Exception e) {
                 e.printStackTrace();
Index: src/main/java/com/xpn/xwiki/user/api/XWikiRightService.java
===================================================================
--- src/main/java/com/xpn/xwiki/user/api/XWikiRightService.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/user/api/XWikiRightService.java	(working copy)
@@ -23,14 +23,21 @@
 
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.AccessLevel;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 
 import java.util.List;
 
 public interface XWikiRightService {
-    public boolean checkAccess(String action, XWikiDocument doc, XWikiContext context) throws XWikiException;
+    public boolean checkAccess(DocumentAction action, XWikiDocument doc, XWikiContext context) throws XWikiException;
 
-    public boolean hasAccessLevel(String right, String username, String docname, XWikiContext context) throws XWikiException;
+    public boolean hasAccessLevel(AccessLevel right, String username, String docname, XWikiContext context) throws XWikiException;
+    
+    /**
+     * @deprecated use {@link XWikiRightService#hasAccessLevel(AccessLevel, String, String, XWikiContext)} 
+     */
+    public boolean hasAccessLevel(String right, String username, String docname, XWikiContext context) throws XWikiException;    
 
     public boolean hasProgrammingRights(XWikiContext context);
 
@@ -38,5 +45,13 @@
 
     public boolean hasAdminRights(XWikiContext context);
 
+    /**
+     * @deprecated use {@link XWikiRightService#listRegularLevels(XWikiContext)} and 
+     * {@link XWikiRightService#listGlobalLevels(XWikiContext)} 
+     */
     public List listAllLevels(XWikiContext context) throws XWikiException;
+    
+    public List listRegularLevels(XWikiContext context) throws XWikiException;
+    
+    public List listGlobalLevels(XWikiContext context) throws XWikiException;
 }
